'Compileroption -s gui
#include "freetype2/freetype.bi"

#include "BitmapFont.bi"

#include "sGUI\sGUI.bas"
#include once "sGUI\MessageBox.bas"
#include once "sGUI\StringGadget.bas"
#include once "sGUI\SimpleGadget.bas"
#include once "sGUI\FileRequester.bas"
#include once "sGUI\Label.bas"
#include once "sGUI\RadioButton.bas"
#include once "sGUI\ScrollBar.bas"
using sGUI

dim as integer scrnw,scrnh
scrnw=600
scrnh=590
screenres scrnw,scrnh,32
width scrnw\8,scrnh\16
InitGFX

dim as FT_Library library
if (FT_Init_FreeType(@library) <> 0) then MessageBox (10,10,"FT_Init_FreeType() failed","!!!",1): End 1
dim as FT_Face face
dim as FT_Bitmap ptr FTbitmap
dim as integer FT_BitmapPitch
dim as BitmapFont ptr BMPFont=new BitmapFont
dim as integer pt,tmpheight,dpi, charspace
dim as uinteger PixelColor
dim as single gammavalue
dim as integer thresholdvalue,colortype
colortype=1
gammavalue=1
thresholdvalue=127
BMPFont->firstchar=32
BMPFont->lastchar=127
BMPFont->imgwidth=0
BMPFont->imgheight=0
BMPFont->PlotType=1
BMPFont->PenColor=&H000000
BMPFont->BackgroundColor=&HFFFFFF
pt=30
dpi=96
charspace=1

dim as integer xo,yo,plotwinwidth,plotwinheight,cutwidth,cutheight,plotwinposx,plotwinposy
plotwinposx=21
plotwinposy=440
plotwinwidth=541
plotwinheight=70
cutwidth=0
cutheight=0
xo=0
yo=0
dim as any ptr cut=imagecreate(plotwinwidth,plotwinheight)

dim as EventHandle ptr event
event=CreateEventHandle

dim as Gadget ptr strg_fname, smpl_open
dim as Gadget ptr strg_pt, lbl_pt
dim as Gadget ptr lbl_firstchar, lbl_lastchar, lbl_dpi, strg_firstchar, strg_lastchar, strg_dpi
dim as Gadget ptr rb_plottype1, rb_plottype2, rb_plottype3, lbl_charspace, strg_charspace

dim as Gadget ptr lbl_PenColor,lbl_background,strg_PenColor,strg_background
dim as Gadget ptr rb_Normal, rb_Gamma, rb_TwoColors
dim as Gadget ptr strg_gamma,strg_threshold

dim as Gadget ptr smpl_render
dim as Gadget ptr strg_StatusText,sb_hview,sb_vview
dim as Gadget ptr smpl_save

FrameT (10, 10, scrnw-20, 155, "Font & Freetype Library Render Options")
smpl_open=AddSimpleGadget(event,470,20,110,25,"Open Font")

strg_fname=AddStringGadget(event,20,20,54,,,1)

lbl_pt=AddLabel(event,20,65,"Font Height (pt):")
strg_pt=AddStringGadget(event,170,60,4,str(pt),,1)

lbl_dpi=AddLabel(event,20,95,"Resolution (dpi):")
strg_dpi=AddStringGadget(event,170,90,4,str(dpi),,1)

lbl_firstchar=AddLabel(event,20,135,"ASCII Range from:")
strg_firstchar=AddStringGadget(event,170,130,4,str(BMPFont->firstchar),,1)

lbl_lastchar=AddLabel(event,220,135,"to")
strg_lastchar=AddStringGadget(event,250,130,4,str(BMPFont->lastchar),,1)

rb_plottype1=AddRadioButton(event,240,60,1,"DRAW STRING optimized",0)
rb_plottype2=AddRadioButton(event,240,80,0,"Freetype Original Style",rb_plottype1)
rb_plottype3=AddRadioButton(event,240,100,0,"condensed",rb_plottype1)
lbl_firstchar=AddLabel(event,450,60,"--> Space:")
strg_charspace=AddStringGadget(event,540,55,4,str(charspace),1)

FrameT (10, 190, scrnw-20, 140, "Color Options")

lbl_PenColor=AddLabel(event,20,205, "Pen (hex):")
strg_PenColor=AddStringGadget(event,120,200,7,hex(BMPFont->PenColor),4)

lbl_background=AddLabel(event,300,205,"Background (hex):")
strg_background=AddStringGadget(event,450,200,7,hex(BMPFont->BackgroundColor),4)

rb_Normal=AddRadioButton(event,20,240,1,"normal",0)
rb_Gamma=AddRadioButton(event,20,270,0,"Gamma (0.1 - 10):",rb_Normal)
rb_TwoColors=AddRadioButton(event,20,300,0,"Two Colors Only, Threshold (0 - 255):",rb_Normal)

strg_Gamma=AddStringGadget(event,190,265,4,str(gammavalue),,1)
strg_Threshold=AddStringGadget(event,340,295,4,str(thresholdvalue),,1)

smpl_render=AddSimpleGadget(event,150,350,300,25,"Render")


FrameT (10, 400, scrnw-20,137, "rendered Bitmap Font in Memory")
strg_StatusText=AddStringGadget(event,20,410,69,,,1)
sb_hview=AddScrollBar (event,plotwinposx,plotwinposy+plotwinheight+1,plotwinwidth,0,BMPFont->imgwidth,xo,plotwinwidth,0)
sb_vview=AddScrollBar (event,plotwinposx+plotwinwidth+1,plotwinposy,plotwinheight,0,BMPFont->imgheight,yo,plotwinheight,1)

smpl_save=AddSimpleGadget(event,150,555,300,25,"Save Bitmap Font")

GadgetSleep(strg_fname)
GadgetOn(smpl_open)
GadgetSleep(lbl_pt,smpl_save)

dim as FilenameInfo FontName,BMPName
'FontName.Path="C:\Windows\Fonts\"
dim as string oldpath
dim as string StatusText

do
  event->xSleep(1)
  if event->GADGETMESSAGE then
    select case event->GADGETMESSAGE

      case smpl_open
        FontName=FileRequester(100,0,"Open Font",FontName.Path,,1)
        if FT_New_Face(library, FontName.PathAndFile, 0, @face) = 0 then
          SetString (strg_fname,FontName.File)
          GadgetOn(lbl_pt,smpl_render)
          if GetSelect(rb_plottype1)=0 then GadgetSleep(strg_charspace)
          if GetSelect(rb_Gamma)=0 then GadgetSleep(strg_gamma)
          if GetSelect(rb_TwoColors)=0 then GadgetSleep(strg_threshold)
        else
          MessageBox (100,100,"File not opened","Error",1)
          SetString (strg_fname,"")
          GadgetSleep(lbl_pt,smpl_render)
        end if

      case rb_plottype1
        GadgetOn(strg_charspace)

      case rb_plottype2
        GadgetSleep(strg_charspace)

      case rb_plottype3
        GadgetSleep(strg_charspace)

      case rb_Normal
        colortype=1
        GadgetSleep(strg_gamma)
        GadgetSleep(strg_threshold)

      case rb_Gamma
        colortype=2
        GadgetOn(strg_gamma)
        GadgetSleep(strg_threshold)

      case rb_TwoColors
        colortype=3
        GadgetSleep(strg_gamma)
        GadgetOn(strg_threshold)

      case sb_hview
          xo=GetScrollbarVal(sb_hview)
          line (plotwinposx,plotwinposy)-(plotwinposx+plotwinwidth-1,plotwinposy+plotwinheight-1),BMPFont->BackgroundColor,BF
          get BMPFont->img,(xo,yo)-(xo+cutwidth-1,yo+cutheight-1),cut
          put (plotwinposx,plotwinposy),cut,pset

      case sb_vview
          yo=GetScrollbarVal(sb_vview)
          line (plotwinposx,plotwinposy)-(plotwinposx+plotwinwidth-1,plotwinposy+plotwinheight-1),BMPFont->BackgroundColor,BF
          get BMPFont->img,(xo,yo)-(xo+cutwidth-1,yo+cutheight-1),cut
          put (plotwinposx,plotwinposy),cut,pset

      case smpl_render
        'Daten aus GUI holen
        BMPFont->ClearAll
        BMPFont->firstchar=val(GetString(strg_firstchar))
        BMPFont->lastchar=val(GetString(strg_lastchar))
        BMPFont->PenColor=val("&H" & GetString(strg_PenColor))
        BMPFont->BackgroundColor=val("&H" & GetString(strg_background))

        pt=val(GetString(strg_pt))
        dpi=val(GetString(strg_dpi))
        charspace=val(GetString(strg_charspace))

        gammavalue=val(GetString(strg_gamma))
        thresholdvalue=val(GetString(strg_threshold))

        'Limiter
        if BMPFont->firstchar<0 then BMPFont->firstchar=0
        if BMPFont->firstchar>255 then BMPFont->firstchar=255
        if BMPFont->lastchar<0 then BMPFont->lastchar=0
        if BMPFont->lastchar>255 then BMPFont->lastchar=255
        if BMPFont->firstchar>BMPFont->lastchar then swap BMPFont->firstchar,BMPFont->lastchar
        if pt<1 then pt=1
        if charspace<0 then charspace=0
        if GetSelect(rb_plottype1) then BMPFont->PlotType=1
        if GetSelect(rb_plottype2) then BMPFont->PlotType=2
        if GetSelect(rb_plottype3) then BMPFont->PlotType=3
        if gammavalue<0.1 then gammavalue=.1
        if gammavalue>10 then gammavalue=10
        if thresholdvalue<0 then thresholdvalue=0
        if thresholdvalue>255 then thresholdvalue=255


        '1. alle Gren zu jedem Zeichen auslesen, Hhe BaseLine berechnen
        if FT_Set_Char_Size( face, 0, pt*64,dpi,dpi)=0 then
          FT_BitmapPitch=face->glyph->bitmap.pitch
          for i as integer=BMPFont->firstchar to BMPFont->lastchar
            if FT_Load_Char(face, i, FT_LOAD_RENDER)=0 then
              BMPFont->CharSet(i).OffsetX       =BMPFont->imgwidth
              BMPFont->CharSet(i).AdvanceX      =face->glyph->advance.x shr 6
              BMPFont->CharSet(i).GlyphWidth    =face->glyph->bitmap.width
              BMPFont->CharSet(i).GlyphHeight   =face->glyph->bitmap.rows
              BMPFont->CharSet(i).GlyphLeft     =face->glyph->bitmap_left
              BMPFont->CharSet(i).GlyphTop      =face->glyph->bitmap_top
              select case  BMPFont->PlotType
                case 1'FB optimized
                  if BMPFont->CharSet(i).GlyphWidth>0 then BMPFont->CharSet(i).AdvanceX = BMPFont->CharSet(i).GlyphWidth
                  BMPFont->CharSet(i).AdvanceX +=charspace
                  BMPFont->CharSet(i).GlyphLeft=charspace/2
                  BMPFont->imgwidth += BMPFont->CharSet(i).AdvanceX
                case 2'FreeType
                  BMPFont->imgwidth += BMPFont->CharSet(i).AdvanceX
                case 3'condensed
                  BMPFont->imgwidth += BMPFont->CharSet(i).GlyphWidth
              end select
              'Baseline... eigentlich nur Suche nach grter Enfernung nach oben
              if BMPFont->BaseLine < BMPFont->CharSet(i).GlyphTop then BMPFont->BaseLine = BMPFont->CharSet(i).GlyphTop
            end if
          next i

          '2.ausgehend von der nun bekannten BaseLine die Gesamthhe des Fonts ermitteln
          '.GlyphTop steht noch im Bezug zur BaseLine, Umrechnung auf "Abstand von oben"
          'damit gilt jetzt bei allen Werten das Screen/Image Koordinatensystem
          tmpheight=0
          for i as integer=BMPFont->firstchar to BMPFont->lastchar
            'GlyphTop "umrechnen"
            BMPFont->CharSet(i).GlyphTop = BMPFont->BaseLine - BMPFont->CharSet(i).GlyphTop
            'Fonthhe...
            tmpheight =BMPFont->CharSet(i).GlyphTop + BMPFont->CharSet(i).GlyphHeight
            if BMPFont->imgheight < tmpheight then BMPFont->imgheight=tmpheight
          next i

          CreateImage(BMPFont->img,BMPFont->imgwidth,BMPFont->imgheight)
          ImageInfo(BMPFont->img,BMPFont->imgwidth,BMPFont->imgheight,BMPFont->imgbpp,BMPFont->imgpitch,BMPFont->imgpxldata)

          line BMPFont->img,(0,0)-(BMPFont->imgwidth-1,BMPFont->imgheight-1),BMPFont->BackgroundColor,BF

          '3. alle Zeichen ins Image plotten
          for i as integer=BMPFont->firstchar to BMPFont->lastchar
            if FT_Load_Char(face,i,FT_LOAD_RENDER)=0 then
              FTbitmap = @face->glyph->bitmap
              for y As integer = 0 To (FTbitmap->rows - 1)
                for x As integer = 0 To (FTbitmap->width - 1)
                  dim as ubyte a = FTbitmap->buffer[y * FTbitmap->pitch + x]
                  if a then
                    select case colortype
                      case 1
                        PixelColor=MixColor(BMPFont->BackgroundColor, BMPFont->PenColor, a)

                      case 2
                        PixelColor=MixColor(BMPFont->BackgroundColor, BMPFont->PenColor, ((a / 255) ^ gammavalue) * 255 )
                      
                      case 3
                        if a>=thresholdvalue then PixelColor=BMPFont->PenColor else PixelColor=BMPFont->BackgroundColor

                    end select

                    select case  BMPFont->PlotType
                      case 1,2
                        pset BMPFont->img, (BMPFont->CharSet(i).OffsetX + BMPFont->CharSet(i).GlyphLeft + x, BMPFont->CharSet(i).GlyphTop + y),PixelColor
                      case 3
                        pset BMPFont->img, (BMPFont->CharSet(i).OffsetX + x, y),PixelColor
                    end select
                  end if
                next x
              next y
            end if
          next i

          'GUI
          SetString(strg_firstchar,str(BMPFont->firstchar))
          SetString(strg_lastchar,str(BMPFont->lastchar))
          SetString(strg_charspace,str(charspace))
          SetString(strg_gamma,str(gammavalue))
          SetString(strg_threshold,str(thresholdvalue))

          StatusText="Font: " & FontName.FileWithoutExt & "  " & _
          "Bitmap Size: " & BMPFont->imgwidth & "x" & BMPFont->imgheight
          
          setstring(strg_StatusText,StatusText)
          GadgetOn(sb_hview,smpl_save)
          xo=0
          yo=0
          if BMPFont->imgwidth<plotwinwidth then cutwidth=BMPFont->imgwidth else cutwidth=plotwinwidth
          if BMPFont->imgheight<plotwinheight then cutheight=BMPFont->imgheight else cutheight=plotwinheight
          
          ModifyScrollBar(sb_hview,0,BMPFont->imgwidth-1,xo)
          ModifyScrollBar(sb_vview,0,BMPFont->imgheight-1,yo)
          
          CreateImage(cut,cutwidth,cutheight,BMPFont->BackgroundColor)
          line (plotwinposx,plotwinposy)-(plotwinposx+plotwinwidth-1,plotwinposy+plotwinheight-1),BMPFont->BackgroundColor,BF
          get BMPFont->img,(xo,yo)-(xo+cutwidth-1,yo+cutheight-1),cut          
          put (plotwinposx,plotwinposy),cut,pset
        end if

      case smpl_save
        BMPName=FileRequester(100,230,"Save BMP",BMPName.Path,FontName.FileWithoutExt & ".bmp")
        if BMPName.PathAndFile<>"" then
          chdir BMPName.Path
          BMPFont->SaveFont(BMPName.File)
          StatusText &="...saved"
          setstring(strg_StatusText,StatusText)
        end if
    end select
  end if
loop until event->EXITEVENT

DestroyEventHandle (event)
delete BMPFont
